#ifndef ELM_INTERFACE_ATSPI_WINDOW_EO_HH
#define ELM_INTERFACE_ATSPI_WINDOW_EO_HH
#include <Eo.h>

extern "C" {
#include "elm_interface_atspi_window.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace elm { namespace interface { namespace atspi { 
struct Window;
} } } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::elm::interface::atspi::Window> : ::std::true_type {}; } }

namespace eo_cxx {
namespace elm { namespace interface { namespace atspi { 
struct Window {
   static Eo_Class const* _eo_class()
   {
      return ELM_INTERFACE_ATSPI_WINDOW_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::elm::interface::atspi::Window() const;
   operator ::elm::interface::atspi::Window&();
   operator ::elm::interface::atspi::Window const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Window> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Window const > operator&() const { return {this}; }
   /// @endcond
};
} } } 
}
namespace elm { namespace interface { namespace atspi { 
struct Window : ::efl::eo::concrete
{
   explicit Window( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Window(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Window(Window const& other) = default;
   Window(Window&& other) = default;
   Window& operator=(Window const& other) = default;
   Window& operator=(Window&& other) = default;
   Window()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Window( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Window(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   static Eo_Class const* _eo_class()
   {
      return ELM_INTERFACE_ATSPI_WINDOW_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct window_created_event
   {
      static Eo_Event_Description const* description()
      { return ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_CREATED; }
      typedef void parameter_type;
   } const window_created_event;
   static struct window_destroyed_event
   {
      static Eo_Event_Description const* description()
      { return ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_DESTROYED; }
      typedef void parameter_type;
   } const window_destroyed_event;
   static struct window_activated_event
   {
      static Eo_Event_Description const* description()
      { return ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_ACTIVATED; }
      typedef void parameter_type;
   } const window_activated_event;
   static struct window_deactivated_event
   {
      static Eo_Event_Description const* description()
      { return ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_DEACTIVATED; }
      typedef void parameter_type;
   } const window_deactivated_event;
   static struct window_maximized_event
   {
      static Eo_Event_Description const* description()
      { return ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_MAXIMIZED; }
      typedef void parameter_type;
   } const window_maximized_event;
   static struct window_minimized_event
   {
      static Eo_Event_Description const* description()
      { return ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_MINIMIZED; }
      typedef void parameter_type;
   } const window_minimized_event;
   static struct window_restored_event
   {
      static Eo_Event_Description const* description()
      { return ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_RESTORED; }
      typedef void parameter_type;
   } const window_restored_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Window> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Window const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Window) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Window>::value, "");
} } } 
#include "elm_interface_atspi_window.eo.impl.hh"
#endif
